package betterwithmods.common.world.gen.village.field;

import net.minecraft.block.BlockTallGrass;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.MathHelper;
import net.minecraft.world.World;
import net.minecraft.world.gen.structure.StructureBoundingBox;
import net.minecraft.world.gen.structure.StructureComponent;
import net.minecraft.world.gen.structure.StructureVillagePieces;

import java.util.List;
import java.util.Random;

/**
 * Created by tyler on 5/21/17.
 */
public class BWField2 extends BWFieldBase {

    public BWField2() {
    }

    public BWField2(StructureVillagePieces.Start start, int p_i45569_2_, Random rand, StructureBoundingBox p_i45569_4_, EnumFacing facing) {
        super(start, p_i45569_2_);
        this.func_186164_a(facing);
        this.field_74887_e = p_i45569_4_;
    }
    @Override
    public Class<?> getComponentClass() {
        return BWField2.class;
    }

    /**
     * second Part of Structure generating, this for example places Spiderwebs, Mob Spawners, it closes
     * Mineshafts at the end, it adds Fences...
     */
    public boolean func_74875_a(World worldIn, Random randomIn, StructureBoundingBox structureBoundingBoxIn) {
        if (this.field_143015_k < 0) {
            this.field_143015_k = this.func_74889_b(worldIn, structureBoundingBoxIn);
            if (this.field_143015_k < 0) {
                return true;
            }
            this.field_74887_e.func_78886_a(0, this.field_143015_k - this.field_74887_e.field_78894_e + 4 - 1, 0);
        }

        IBlockState iblockstate = this.func_175847_a(Blocks.field_150364_r.func_176223_P());
        IBlockState filler = this.func_175847_a(Blocks.field_150346_d.func_176223_P());
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 1, 0, 6, 4, 8, Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 1, 2, 0, 7, Blocks.field_150458_ak.func_176223_P(), Blocks.field_150458_ak.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 4, 0, 1, 5, 0, 7, Blocks.field_150458_ak.func_176223_P(), Blocks.field_150458_ak.func_176223_P(), false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 0, 0, 0, 0, 0, 8, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 6, 0, 0, 6, 0, 8, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 0, 5, 0, 0, iblockstate, iblockstate, false);
        this.func_175804_a(worldIn, structureBoundingBoxIn, 1, 0, 8, 5, 0, 8, iblockstate, iblockstate, false);

        for (int i = 1; i <= 7; ++i) {
            for (int j = 1; j <= 5; ++j) {
                if (j % 3 != 0 && randomIn.nextInt(20) == 0) {
                    this.func_175811_a(worldIn, Blocks.field_150329_H.func_176223_P().func_177226_a(BlockTallGrass.field_176497_a, BlockTallGrass.EnumType.GRASS), j, 1, i, structureBoundingBoxIn);
                }
            }
        }

        for (int j1 = 0; j1 < 9; ++j1) {
            for (int k1 = 0; k1 < 7; ++k1) {
                this.func_74871_b(worldIn, k1, 4, j1, structureBoundingBoxIn);
                this.func_175808_b(worldIn, filler, k1, -1, j1, structureBoundingBoxIn);
            }
        }

        return true;
    }

    @Override
    public StructureVillagePieces.PieceWeight getVillagePieceWeight(Random random, int size) {
        return new StructureVillagePieces.PieceWeight(BWField2.class, 3, MathHelper.func_76136_a(random, 2 + size, 4 + size * 2));
    }

    @Override
    public StructureVillagePieces.Village buildComponent(StructureVillagePieces.PieceWeight villagePiece, StructureVillagePieces.Start startPiece, List<StructureComponent> pieces, Random random, int p1, int p2, int p3, EnumFacing facing, int p5) {
        StructureBoundingBox structureboundingbox = StructureBoundingBox.func_175897_a(p1, p2, p3, 0, 0, 0, 7, 4, 9, facing);
        return StructureVillagePieces.Village.func_74895_a(structureboundingbox) && StructureComponent.func_74883_a(pieces, structureboundingbox) == null ? new BWField2(startPiece, p5, random, structureboundingbox, facing) : null;
    }
}
